VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TracToMsprj"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private trac As TracXmlRpcCtrl
Private prjObj As Project
Private tree As TaskNode

Private Sub Class_Initialize()
    Set trac = New TracXmlRpcCtrl
    Set tree = New TaskNode
End Sub

Public Sub Init(ByRef prj As Project, ByVal URL As String, ByVal prjname As String, ByVal User As String, ByVal passwd As String)
    Set prjObj = prj
    Call trac.Init(URL, prjname, User, passwd, True)
End Sub


Public Sub CreateProject(ByVal query As String)
    Dim tsk As task
    While prjObj.tasks.Count <> 0
        For Each tsk In prjObj.tasks
            Debug.Print tsk.id
            tsk.Delete
        Next
    Wend
    
    Dim tikets  As Collection
    Dim copys As Collection
    Set copys = New Collection
    
    Dim t  As Collection
    Set tikets = trac.queryTickets(query) '* "status!=closed")
    Dim tree As New TaskNode
    Set tree = tree.CreateNode(0, 0, 0, 0)
    
    For Each t In tikets
        copys.Add t, Str(GetProperty("id", t))
    Next
    
    Dim appendIds As Collection
    Dim nextIds As Collection
    Dim id As Variant
    
    Set appendIds = New Collection
    Set nextIds = New Collection
    Call appendIds.Add(0)
    Do While copys.Count <> 0
        If appendIds.Count = 0 Then
            Exit Do
        End If
        For Each id In appendIds
            Call AppendTasksByPid(prjObj, tree, copys, id, nextIds)
        Next
        Set appendIds = nextIds
        Set nextIds = New Collection
    Loop
    
    Dim nodeList As Collection
    Set nodeList = New Collection
    Dim task As task
    Dim i As Long
    Dim diffLv As Long
    Call tree.GetList(nodeList)
    Dim node As TaskNode
    For Each node In nodeList
        Set t = trac.findTicket(tikets, node.TracTaskId)
        If Not t Is Nothing Then
            Set task = AppendTaskToMsPrj(prjObj, t)
            node.MsProjTaskId = task.id
            diffLv = node.Depth - task.OutlineLevel
            For i = 1 To Abs(diffLv)
                If diffLv > 0 Then
                    Call task.OutlineIndent
                Else
                    Call task.OutlineOutdent
                End If
            Next i
        End If
    Next

End Sub
Private Sub AppendTasksByPid(ByRef prj As Project, ByRef tree As TaskNode, ByRef list As Collection, ByVal parentId As Long, ByRef appendIds As Collection)
    Dim t As Collection
    Dim node As TaskNode
    Dim task As task

    For Each t In list
        If Val(GetProperty("parents", t)) = parentId Then
            Set node = tree.FindNode(Val(GetProperty("parents", t)))
            If Not node Is Nothing Then
                Dim id  As Long
                id = GetProperty("id", t)
                appendIds.Add id
                Call node.AppendNode(id, 0)
                list.Remove Str(id)
            End If
        End If
    Next
End Sub
Private Function AppendTaskToMsPrj(ByRef prj As Project, ByRef t As Collection) As task
    Dim target As task
    Dim owner As String
    Dim owner_key As Long
    
    Set target = prj.tasks.Add(GetProperty("summary", t))
    
    If GetProperty("due_assign", t) <> "" Then
        target.Start = CDate(GetProperty("due_assign", t))
    End If
    If GetProperty("due_assign", t) <> "" Then
        target.Finish = CDate(GetProperty("due_close", t))
    End If
    
    owner = GetProperty("owner", t)
    If owner <> "" Then
        target.ResourceNames = owner
'        owner_key = FindResource(owner, prj.Resources)
'        If owner_key = 0 Then
'            Call prj.Resources.Add(owner)
'            owner_key = FindResource(owner, prj.Resources)
'        End If
'
'        target.Assignments.Add target.id, owner_key
    End If
    
    target.Notes = GetProperty("description", t)
    target.HyperlinkHREF = trac.URL & "/ticket/" & GetProperty("id", t)
    target.Hyperlink = "#" & GetProperty("id", t)
    
    If IsNumeric(GetProperty("complete", t)) Then
        target.PercentComplete = Val(GetProperty("complete", t))
    End If

    Set AppendTaskToMsPrj = target
End Function

Private Function IsExistKey(ByVal key, ByRef cll) As Boolean
On Error GoTo err
    Dim v As Variant
    v = cll.item(key)
    IsExistKey = True
    Exit Function
err:
   IsExistKey = False
End Function
Private Function FindResource(ByVal owner As String, ByRef res As Resources) As Long
    Dim r As Resource
    FindResource = 0
    For Each r In res
        If r.name = owner Then
            FindResource = r.id
            Exit Function
        End If
    Next
End Function
Private Function GetCollectionValue(ByVal key, ByRef cll) As Variant
On Error GoTo err
    Dim v As Variant
    GetCollectionValue = cll.item(key)
    Exit Function
err:
   GetCollectionValue = vbEmpty
End Function
Private Function GetProperty(ByVal name, ByRef task As Collection) As Variant
    Dim v As Variant
    Set v = task.item(name)
    GetProperty = convertData(v.value, v.DataType)
End Function
