VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TracXmlRpcCtrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'!
'! @class TracXmlRpcCtrl
'! @brief TracXMLRPC̑
'! ȉQlɂ܂B
'! http://zakizaki.cocolog-nifty.com/software/2009/05/tracxmlrpcvba-9.html
'!
Private m_XmlRpc As XmlRpcCtrl
Private m_sPrjName As String            '* vWFNg
Private m_sTracRootUrl As String        '* http://127.0.0.1:8080/trac


'*
'* RXgN^
'*
Private Sub Class_Initialize()
    Set m_XmlRpc = New XmlRpcCtrl
End Sub
Public Property Get URL() As String
    URL = m_sTracRootUrl & "/" & m_sPrjName
End Property
'*
'* 
'* @param[in] URL trac̃[gURL ex.http://localhost:8080/trac
'* @param[in] projectName vWFNg
'* @param[in] user [U
'* @param[in] pw pX[h
'* @param[in] ignoreCert true ̏ꍇ͔F؃G[𖳎
'* @return true / false
'*
Public Function Init(ByVal URL As String, ByVal projectName As String, ByVal User As String, ByVal pw As String, Optional ByVal ignoreCert As Boolean = False) As Boolean
    m_sTracRootUrl = URL
    m_sPrjName = projectName
    m_XmlRpc.URL = m_sTracRootUrl & "/" & m_sPrjName & "/login/xmlrpc"
    m_XmlRpc.Password = pw
    m_XmlRpc.User = User
    m_XmlRpc.IgnoreCertError = ignoreCert
End Function

'*
'* IDw肵ă`Pbg̏擾܂
'* @param[in] id `PbgID
'*
Public Function getTicket(ByVal id As String) As Collection
    Dim param As New XmlRpcParamMgr
    Call param.Add("int", id)
    
    ' struct̎擾.
    If Not m_XmlRpc.GetStruct("ticket.get", param, getTicket) Then
        Exit Function
    End If
    
    Dim idProp As New XmlRpcMember
    idProp.DataType = "int"
    idProp.name = "id"
    idProp.value = id
    
    getTicket.Add idProp, "id"
    
End Function

Public Function getTicketChangeLog(ByVal id As Long) As Collection
    Dim param As New XmlRpcParamMgr
    Call param.Add("int", id)
    
    Set getTicketChangeLog = New Collection
    
    Dim xmldoc As New MSXML2.DOMDocument
    If Not m_XmlRpc.GetXMLDocument("ticket.changeLog", param, xmldoc) Then
        Exit Function
    End If
    
    Dim datas As IXMLDOMNodeList
    Set datas = xmldoc.selectNodes("//params/param/value/array/data/*")
    Dim node As IXMLDOMNode
    Dim log As ChangeLog
    
    For Each node In datas
        Set log = New ChangeLog
        Call log.Init(node)
        getTicketChangeLog.Add log
    Next

End Function
'*
'* NG[w肵ă`Pbg̈ꗗ擾
'* @param[in] qstr NG[
'*
Public Function queryTickets(ByVal qstr As String) As Collection
    Dim param As New XmlRpcParamMgr
    Set queryTickets = New Collection
    
    Call param.Add("string", qstr)
    Dim bRet As Boolean
    Dim cllResult As Collection
    bRet = m_XmlRpc.GetArray("ticket.query", param, cllResult)
    Dim data As XmlRpcData
    Dim ticket As Collection
    For Each data In cllResult
        Set ticket = getTicket(data.value)
        Call queryTickets.Add(ticket, data.value)
    Next
End Function

'*
'* `Pbg̈ꗗwID̃`Pbg擾
'* @param[in] tasks `Pbg̈ꗗ
'* @param[in] id Ώۂ̃^XN
'* @return collection ^XN@݂ȂꍇNothing
Public Function findTicket(ByRef tasks As Collection, ByVal id As Long) As Collection
    For Each findTicket In tasks
        If CLng(findTicket.item("id").value) = id Then
            Exit Function
        End If
    Next
    Set findTicket = Nothing
End Function

'*
'* SĂWikiy[W擾
'* @return y[WXg
'*
Public Function getAllWikiPages() As Collection
    Set getAllWikiPages = New Collection
    Dim param As New XmlRpcParamMgr
    Dim bRet As Boolean
    Dim cllResult As Collection
    bRet = m_XmlRpc.GetArray("wiki.getAllPages", param, cllResult)
    Dim data As XmlRpcData
    For Each data In cllResult
        Call getAllWikiPages.Add(data.value)
    Next
End Function

'*
'* Wikiy[W̎擾
'* @param[in] y[W
'* @return y[W̓e
'*
Public Function getWikiPage(ByVal sPageName) As String
    Dim param As New XmlRpcParamMgr
    Call param.Add("string", sPageName)
    
    Call m_XmlRpc.GetValue("wiki.getPage", param, getWikiPage)

End Function
'*
'* Wikiy[WHTMLŎ擾
'* @param[in] y[W
'* @return y[W̓e
'*
Public Function getWikiPageHTML(ByVal sPageName) As String
    Dim param As New XmlRpcParamMgr
    Call param.Add("string", sPageName)
    
    Call m_XmlRpc.GetValue("wiki.getPageHTML", param, getWikiPageHTML)

End Function

' Ql̃IWĩR[hł.
' http://zakizaki.cocolog-nifty.com/software/2009/05/tracxmlrpcvba-9.html
''Copyright (c) 2009 Yuji OKAZAKI. All rights reserved.
''
''Redistribution and use in source and binary forms, with or without modification, are permitted provided
''that the following conditions are met:
''
'' 1. Redistributions of source code must retain the above copyright notice, this list of conditions and
''   the following disclaimer.
'' 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions
''   and the following disclaimer in the documentation and/or other materials provided with the
''   distribution.
''
''THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
''INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
''A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE
''FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
''NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
''OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
''STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
''THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'
'Dim m_URL As String
'Dim m_projectName As String
'Dim m_user As String
'Dim m_pw As String
'
'Dim m_milestone As Collection
'Dim m_status As Collection
'Dim m_version As Collection
'Dim m_component As Collection
'Dim m_priority As Collection
'Dim m_resolution As Collection
'Dim m_severity As Collection
'Dim m_type As Collection
'Dim m_fieldN As Collection
'Dim m_fieldL As Collection
'Dim m_initialized As Boolean
'
'Private Sub Class_Initialize()
'    m_initialized = False
'End Sub
'
''NX܂Dê͎悤Ɏw肵Ă
''ڑłȂꍇƂ͂ŃG[܂D
''URL:http://localhost/trac
''projectName:SampleProject
''user:admin
''pw:admin
'Public Sub init(URL As String, projectName As String, user As String, pw As String)
'    m_URL = URL
'    m_projectName = projectName
'    m_user = user
'    m_pw = pw
'    getStringArray m_type, "type"
'    getStringArray m_status, "status"
'    getStructArray m_resolution, "resolution"
'    getStructArray m_milestone, "milestone"
'    getStructArray m_version, "version"
'    getStructArray m_component, "component"
'    getStringArray m_priority, "priority"
'    getStringArray m_severity, "severity"
'    getTicketFields m_fieldN, m_fieldL, "field", "ticket.getTicketFields"
'    m_initialized = True
'End Sub
'
''IDw肵ă`Pbg̏擾܂
'Public Function getTicket(id As String) As Collection
'    Set getTicket = getStruct("ticket.get", id, "int")
'    getTicket.Add id, "id"
'End Function
'
'Private Function getStruct_sub(method As String, params As String) As Collection
'    Dim d As Collection
'    Set Members = getMember(method, params, "member")
'    If Members Is Nothing Or Members.Length = 0 Then '߂ĂȂ
'        Set getStruct_sub = Nothing
'        Exit Function
'    End If
'    Set d = New Collection
'    Dim n As String, v As String
'    For i = 0 To Members.Length - 1
'        Set oNodeList = Members.Item(i).ChildNodes
'        If oNodeList.Length = 2 Then
'            n = oNodeList(0).text '
'            v = oNodeList(1).text 'l
'            nn = oNodeList(1).ChildNodes(0).nodeName 'm[h
'            If nn = "dateTime.iso8601" Then
'                'tłlĂȂꍇ͂ɓĂȂɒlɂOĂ
'                v = convertDate(v) 'tC
'            End If
'            d.Add v, n 'RNVɒlǉ
''            Debug.Print "    " & n & "=" & v
'        End If
'        yield
'    Next
'    Set getStruct_sub = d
'End Function
'
''TODO:publiv->privateɕύX薳mF
'Private Function getStruct(method As String, name As String, dataType As String) As Collection
'    Dim params As String
'    params = "<param><value><" & dataType & ">" & name & "</" & dataType & "></value></param>"
'    Set getStruct = getStruct_sub(method, params)
'End Function
'
''milestonȅ擾܂.wł͎̂̂̂łD
''"resolution","milestone","version","component","priority","severity"
'Private Sub getStructArray(ByRef d As Collection, typeName As String)
'    getStructArray_Sub d, typeName, "ticket." & typeName & ".getAll"
'End Sub
'
'Private Sub getStructArray_Sub(ByRef d As Collection, typeName As String, method As String)
'    Dim name As String
'    Set d = New Collection
'    Set Members = getMember(method, "", "string")
'    If Members Is Nothing Or Members.Length = 0 Then
'        Exit Sub
'    End If
'    For i = 0 To Members.Length - 1
'        name = Members.Item(i).ChildNodes(0).text
'        Dim c As Collection
'        Debug.Print "s--" & name & "(" & typeName & ")"
'        Set c = getStruct("ticket." & typeName & ".get", name, "string") 'ȂɂȂꍇnamê܂ܖ߂Ă
'        If c Is Nothing Then
'            d.Add name, name
'        Else
'            d.Add c, name
'        End If
''        Debug.Print "e--" & name
'        yield
'    Next
'End Sub
'
''RNVԂ܂DtypeNameɎwł͎̂̂̂łD
''"type","status"
'Private Sub getStringArray(ByRef d As Collection, typeName As String)
'    getStringArray_Sub d, typeName, "ticket." & typeName & ".getAll"
'End Sub
'
'Private Sub getStringArray_Sub(ByRef d As Collection, typeName As String, method As String)
'    Dim name As String
'    Set d = New Collection
'    Set Members = getMember(method, "", "string")
'    If Members Is Nothing Then
'        Exit Sub
'    End If
'    If Members.Length = 0 Then
'        Exit Sub
'    End If
'    For i = 0 To Members.Length - 1
'        Set Item = Members.Item(i)
'        name = Item.text
'        d.Add name
''        Debug.Print "-" & name & "(" & typeName & ")"
'        yield
'    Next
'End Sub
'
''ticket.getTicketFields()TicketField擾邽߂Ɏgp܂D
'Private Sub getTicketFields(ByRef d As Collection, ByRef e As Collection, typeName As String, method As String)
'    Set d = New Collection
'    Set e = New Collection
'    Set Members = getMember(method, "", "struct")
'    If Members Is Nothing Then
'        Exit Sub
'    End If
'    If Members.Length = 0 Then
'        Exit Sub
'    End If
'    Dim c As Collection
'
'    Set c = New Collection
'
'    For i = 0 To Members.Length - 1
'        Dim n As String, v As String
'
'        Set c = New Collection
'        Set oNodeList = Members.Item(i).ChildNodes 'member
'
'        For j = 0 To oNodeList.Length - 1
'            Set oNodeList2 = oNodeList.Item(j).ChildNodes
'            If oNodeList2.Length = 2 Then
'                n = oNodeList2(0).text '
'                v = oNodeList2(1).text 'l
'                c.Add v, n 'RNVɒlǉ
''                Debug.Print "    " & n & "=" & v
'            End If
'            yield
'        Next
''        Debug.Print "=== name=" & c.Item("name") & " label=" & c.Item("label")
'        d.Add c, c.Item("name")
'        e.Add c, c.Item("label")
'        yield
'    Next
'End Sub
'
''XMLRPCłstructVBCollection쐬܂D
'Public Function createStruct(arrayMember As Collection) As String
'    Dim structString As String
'    If arrayMember Is Nothing Then
'        Exit Function
'    End If
'    structString = "<struct>" + vbCrLf
'
'    On Error Resume Next
'    For Each name In m_fieldN
'        Dim fieldName As String, value As String
'        fieldName = name.Item("name")
''        If fieldName <> "id" Then
'            structString = structString + _
'                "<member>" + _
'                    "<name>" + fieldName + "</name>" + _
'                    "<value>" + arrayMember.Item(fieldName) + "</value>" + _
'                "</member>" + vbCrLf
''        End If
'    Next
'    If structString = "<struct>" Then
'        structString = ""
'    Else
'        structString = structString + "</struct>"
'    End If
'    Debug.Print structString
'    createStruct = structString
'End Function
'
'Public Function createTicket(summary As String, description As String, attributes As Collection, notify As Boolean) As Long
''int ticket.create(string summary, string description, struct attributes={}, boolean notify=False)
''Create a new ticket, returning the ticket ID.
'    Dim funcName As String, params As String, dataType As String
'    funcName = "ticket.create"
'    dataType = "int"
'    createTicket = 0
'    Do
'        params = _
'            "<param><value><string>" & summary & "</string></value></param>" & vbCrLf & _
'            "<param><value><string>" & description & "</string></value></param>" & vbCrLf & _
'            "<param><value>" & vbCrLf & _
'                createStruct(attributes) & vbCrLf & _
'            "</value></param>" & vbCrLf & _
'            "<param><value><boolean>" & CStr(Abs(CInt(notify))) & "</boolean></value></param>"
'        Debug.Print params
'        Set Members = getMember(funcName, params, dataType)
'        For i = 0 To Members.Length - 1
'            Set oNodeList = Members.Item(i).ChildNodes
'            createTicket = CLng(oNodeList(0).text)
'            yield
'        Next
'        Exit Do
'    Loop
'End Function
'
'Public Function updateTicket(id As Long, comment As String, attributes As Collection, notify As Boolean) As Collection
''array ticket.update(int id, string comment, struct attributes={}, boolean notify=False)
''Update a ticket, returning the new ticket in the same form as getTicket().
'    Dim funcName As String, params As String, dataType As String
'    funcName = "ticket.update"
'    params = _
'            "<param><value><i4>" & id & "</i4></value></param>" & vbCrLf & _
'            "<param><value><string>" & comment & "</string></value></param>" & vbCrLf & _
'            "<param><value>" & vbCrLf & _
'                createStruct(attributes) & vbCrLf & _
'            "</value></param>" & vbCrLf & _
'            "<param><value><boolean>" & CStr(Abs(CInt(notify))) & "</boolean></value></param>"
'    Debug.Print params
'    Set updateTicket = getStruct_sub(funcName, params)
'End Function
'
''`PbgiCollectionjCollectionԂ܂D
''폜D
''Public Function queryTicket(query As String, enableTree As Boolean) As Collection
'Public Function queryTicket(query As String) As Collection
'    Dim funcName As String, queryString As String, dataType As String
'    funcName = "ticket.query"
'    dataType = "int"
'    Set queryTicket = New Collection
'    Dim ticketId As String
'    ticketId = "0"
'    Do
'        If query = "" Then
'            queryString = ""
'        Else
'            queryString = "<param>" & query & "</param>"
'        End If
'        Set Members = getMember(funcName, queryString, dataType)
'        For i = 0 To Members.Length - 1
'            Set oNodeList = Members.Item(i).ChildNodes
'            ticketId = oNodeList(0).text
'            Set ti = getTicket(ticketId)
'            queryTicket.Add ti, ticketId
'            yield
'        Next
'        Exit Do
'    Loop
'End Function
'
''TracɐڑăX|X𓾂āCw肵^ÖꗗԂ܂D
'Private Function getMember(method As String, params As String, tag As String) As Variant
''    Dim xmlSv As MSXML2.xmlHttp
''    Set xmlSv = New MSXML2.xmlHttp
''QƐݒ肪Ăg悤ɂ
'    Dim xmlSv As Variant
'    Set xmlSv = CreateObject("MSXML2.XMLHTTP")
'    Dim addr As String
'
'    addr = m_URL & "/" & m_projectName & "/login/xmlrpc"
'
'    xmlSv.Open "POST", addr, False, m_user, m_pw
'    xmlSv.setRequestHeader "Method", "POST " & addr & " HTTP/1.1"
'    xmlSv.setRequestHeader "Content-Type", "text/xml"
'
'    On Error GoTo conerr
'
'    If method <> "" Then
'        param = "<?xml version='1.0' encoding='utf-8'?>" & vbNewLine & _
'            "<methodCall>" & _
'            "   <methodName>" & method & "</methodName>" & _
'            "   <params>" & params & "</params>" & _
'            "</methodCall>"
'        Call xmlSv.send(param)
'        '"fault"
'    End If
'    On Error GoTo 0
''    Debug.Print xmlSv.responseText
'    If checkError(xmlSv) = False Then
'        Set getMember = Nothing
'        Exit Function
'    End If
'    Set getMember = xmlSv.responseXML.getElementsByTagName(tag)
'    Exit Function
'conerr:
'    err.Raise vbObjectError + 516, , "T[oɐڑł܂ł"
'End Function
'
''ResponseG[ǂ𔻒f܂B
''TODO:mF
'Private Function checkError(xmlSv As Variant) As Boolean
'    checkError = False
'    Set Members = xmlSv.responseXML.getElementsByTagName("fault")
'    Dim errorMessage As String
'    errorMessage = ""
'    checkError = False
'    If xmlSv.status <= 100 Or xmlSv.status > 200 Then
'        'F؂ɎsƂHTTPɃANZXƂ܂ł̖̏
'        err.Raise vbObjectError + 513, , "T[o玟̃G[Ԃ܂D" & _
'            xmlSv.statusText & "(" & xmlSv.status & ")"
'    ElseIf Members.Length = 0 Then
'        'faultꍇ͂XMLŃX|XmF܂D
'        If xmlSv.responseXML.getElementsByTagName("methodResponse").Length > 0 Then
'            checkError = True
'            Exit Function
'        End If
'        err.Raise vbObjectError + 514, , "XMLł̉܂ł"
'    Else
'        'faultꍇG[bZ[W܂Ƃ߂܂
'        Set Members = xmlSv.responseXML.getElementsByTagName("member")
'        For i = 0 To Members.Length - 1
'            Set oNodeList = Members.Item(i).ChildNodes
'            If oNodeList.Item(0).text = "faultCode" Then
'                errorMessage = errorMessage & "Code=" & oNodeList.Item(1).text
'            End If
'            If oNodeList.Item(0).text = "faultString" Then
'                errorMessage = errorMessage & ":" & oNodeList.Item(1).text
'            End If
'            yield
'        Next
'    End If
'    If errorMessage <> "" Then
''        MsgBox errorMessage
'        err.Raise vbObjectError + 515, , errorMessage
'    End If
'End Function
'
''Ԃ𕶎̎Ԃɕϊ܂
''TODO:9ԂŒœĂ̂ŃVXe̐ݒ肩Ƃ
'Private Function convertDate(text As String) As String
''20090317T16:10:12  Ȃ̂+9HȂƂ
'    Dim d As Date
'    If text = "0" Then 'IĂȂꍇ͂ȂO
'        convertDate = ""
'        Exit Function
'    End If
'    If Len(text) <> 17 Then
'        'K\ĝ͂߂ǂ̂Œ
'        convertDate = ""
'        err.Raise vbObjectError + 515, , "t̃tH[}bgُ̈ł(" & text & ")Trac̃X|X𒲂ׂĂD"
'        Exit Function
'    End If
'    d = DateSerial(Mid$(text, 1, 4), Mid$(text, 5, 2), Mid$(text, 7, 2))
'    d = DateAdd("h", Int(Mid$(text, 10, 2)), d)
'    d = DateAdd("h", 9, d) ''̕ǉ
'    'ɍ킹ĕύX
'    'œ͂̂ɂĂo͎ɕWɂȂĂ
'    d = DateAdd("n", Int(Mid$(text, 13, 2)), d)
'    d = DateAdd("s", Int(Mid$(text, 16, 2)), d)
'    convertDate = Format(d, "yyyy/mm/dd")
'End Function
'
'Public Property Get milestone() As Collection
'    Set milestone = m_milestone
'End Property
'
'Public Property Get version() As Collection
'    Set version = m_version
'End Property
'
'Public Property Get ticketType() As Collection
'    Set ticketType = m_type
'End Property
'
'Public Property Get status() As Collection
'    Set status = m_status
'End Property
'
'Public Property Get component() As Collection
'    Set component = m_component
'End Property
'
'Public Property Get priority() As Collection
'    Set priority = m_priority
'End Property
'
'Public Property Get resolution() As Collection
'    Set resolution = m_resolution
'End Property
'
'Public Property Get severity() As Collection
'    Set severity = m_severity
'End Property
'
'Public Property Get field() As Collection
'    Set field = m_fieldN
'End Property
'
'Public Property Get URL() As String
'    URL = m_URL & "/" & m_projectName
'End Property
'
'Public Property Get initialized() As Boolean
'    initialized = m_initialized
'End Property
'
'Private Sub yield()
'    DoEvents
'End Sub



