VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "XmlRpcCtrl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'!
'! @class XmlRpcCtrl
'! @brief XML-RPC̑
'!
Private m_URL As String             '* XML-RPC𑀍삷URL
Private m_user As String            '* [U
Private m_pw As String              '* pX[h
Private m_IgnoreCertError As Boolean '* TruȅꍇF؃G[𖳎
'*
'* URL擾
'* @return p[^̒l
'*
Public Property Get URL() As String
    URL = m_URL
End Property

'*
'* URLEݒ
'* @param[in] sURL ݒl
'*
Public Property Let URL(ByVal sURL As String)
    m_URL = sURL
End Property
'*
'* User 擾
'* @return p[^̒l
'*
Public Property Get User() As String
    User = m_user
End Property

'*
'* USEREݒ
'* @param[in] sUser ݒl
'*
Public Property Let User(ByVal sUser As String)
    m_user = sUser
End Property
'*
'* Password 擾
'* @return p[^̒l
'*
Public Property Get Password() As String
    User = m_pw
End Property

'*
'* Password ݒ
'* @param[in] sUser ݒl
'*
Public Property Let Password(ByVal sPass As String)
    m_pw = sPass
End Property
'*
'* IgnoreCertError 擾
'* @return True F؃G[𖳎
'*
Public Property Get IgnoreCertError() As Boolean
    IgnoreCertError = m_IgnoreCertError
End Property

'*
'* IgnoreCertError ݒ
'* @param[in] F؃G[𖳎
'*
Public Property Let IgnoreCertError(ByVal value As Boolean)
    m_IgnoreCertError = value
End Property
'*
'* XMLHTTP܂ServerXMLHTTP̍쐬
'* @return XMLHTTP܂ServerXMLHTTP
Private Function CreateXMLHTTP() As Object
    If InStr(m_URL, "https://") = 1 Then
        Set CreateXMLHTTP = New ServerXMLHTTP
        If m_IgnoreCertError Then
            CreateXMLHTTP.setOption SXH_OPTION_IGNORE_SERVER_SSL_CERT_ERROR_FLAGS, SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS
        End If
    Else
        Set CreateXMLHTTP = New XMLHTTP
    End If
End Function
'*
'* XML-RPCXML擾
'* @param[in] method    \bh
'* @param[in] paramMgr  p[^
'* @param[in,out] xmldoc XMLhLg
'* @return true/false
Public Function GetXMLDocument(ByVal method As String, ByRef paramMgr As XmlRpcParamMgr, ByRef xmldoc As MSXML2.DOMDocument) As Boolean
    Dim xmlsv As XMLHTTP
    Set xmlsv = CreateXMLHTTP()
    GetXMLDocument = False
    Dim bRet As Boolean
    bRet = CallMethod(method, paramMgr, xmlsv)
    If Not bRet Then
        Exit Function
    End If
    
    If Not xmldoc.loadXML(xmlsv.responseText) Then
        Exit Function
    End If
    
    GetXMLDocument = True
End Function
'*
'* XML-RPCstruct擾
'* @param[in] method    \bh
'* @param[in] paramMgr  p[^
'* @param[in,out] cllResult XmlRpcMember̃RNV
'* @return true/false
Public Function GetStruct(ByVal method As String, ByRef paramMgr As XmlRpcParamMgr, ByRef cllResult As Collection) As Boolean
    Dim xmldoc As New MSXML2.DOMDocument
    If Not GetXMLDocument(method, paramMgr, xmldoc) Then
        Exit Function
    End If
    
    Dim Members As IXMLDOMNodeList
    Set Members = xmldoc.getElementsByTagName("member")
    
    Set cllResult = New Collection

    Dim sName As String
    Dim sValue As String
    Dim sDataType As String
    Dim i As Long
    
    Dim oNodeList As IXMLDOMNodeList
    Dim oNode As IXMLDOMNode
    
    For i = 0 To Members.Length - 1
        Set oNodeList = Members.item(i).ChildNodes
        sName = Empty
        sValue = Empty
        sDataType = Empty
        For Each oNode In oNodeList
            If oNode.nodeName = "name" Then
                sName = oNode.text
            ElseIf oNode.nodeName = "value" Then
                sValue = oNode.text
                sDataType = oNode.ChildNodes(0).nodeName
            End If
        Next
        If IsEmpty(sName) Or _
           IsEmpty(sValue) Or _
           IsEmpty(sDataType) Then
        Else
            Dim member As XmlRpcMember
            Set member = CreateMember(sName, sDataType, sValue)
            Call cllResult.Add(member, sName)
        End If
        
    Next
    
    GetStruct = True
    Exit Function
End Function

'*
'* XML-RPCstruct擾
'* @param[in] method    \bh
'* @param[in] paramMgr  p[^
'* @param[in,out] cllResult XmlRpcMember̃RNV
'* @return true/false
Public Function GetArray(ByVal method As String, ByRef paramMgr As XmlRpcParamMgr, ByRef cllResult As Collection) As Boolean
    Dim xmldoc As New MSXML2.DOMDocument
    If Not GetXMLDocument(method, paramMgr, xmldoc) Then
        Exit Function
    End If
    Dim Members As IXMLDOMNodeList
    Set Members = xmldoc.selectNodes("//*/array/data/value")
    
    Set cllResult = New Collection

    Dim sValue As String
    Dim sDataType As String
    Dim i As Long
    
    Dim oNode As IXMLDOMNode
    
    
    For Each oNode In Members
        sValue = oNode.text
        sDataType = oNode.ChildNodes(0).nodeName
        
        Dim dt As XmlRpcData
        Set dt = CreateData(sDataType, sValue)
        Call cllResult.Add(dt)
    Next
    
    GetArray = True
    Exit Function
End Function

'*
'* XML-RPCstruct擾
'* @param[in] method    \bh
'* @param[in] paramMgr  p[^
'* @param[in,out] cllResult XmlRpcMember̃RNV
'* @return true/false
Public Function GetValue(ByVal method As String, ByRef paramMgr As XmlRpcParamMgr, ByRef retValue As Variant) As Boolean
    Dim xmlsv As XMLHTTP
    Set xmlsv = CreateXMLHTTP()
    GetValue = False
    Dim bRet As Boolean
    bRet = CallMethod(method, paramMgr, xmlsv)
    If Not bRet Then
        Exit Function
    End If
    Dim Members As IXMLDOMNodeList


    Dim xmldoc As New MSXML2.DOMDocument
    If Not xmldoc.loadXML(xmlsv.responseText) Then
        Exit Function
    End If
    Set Members = xmldoc.selectNodes("//*/value")
    If Members.Length = 0 Then
        Exit Function
    End If

    Dim dt As XmlRpcData
    Set dt = CreateData(Members.item(0).nodeName, Members.item(0).text)
    retValue = dt.value
    
    GetValue = True
    Exit Function
End Function
'*
'* XML-RPC̃\bhsB
'* @param[in] method \bh
'* @param[in] paramMgr p[^̃Xg
'* @param[in] xmlsv XMLp[T[
'* @return True AFalse@s
Private Function CallMethod(ByVal method As String, ByRef paramMgr As XmlRpcParamMgr, ByRef xmlsv As XMLHTTP) As Boolean
    
    Dim param As String
    CallMethod = False
    
    
    xmlsv.Open "POST", m_URL, False, m_user, m_pw
    

    xmlsv.setRequestHeader "Method", "POST " & m_URL & " HTTP/1.1"
    xmlsv.setRequestHeader "Content-Type", "text/xml"
    
    On Error GoTo conerr
    
    If method <> "" Then
        param = "<?xml version='1.0' encoding='utf-8'?>" & vbNewLine & _
            "<methodCall>" & _
            "   <methodName>" & method & "</methodName>" & _
            "   " & paramMgr.GetParameters() & _
            "</methodCall>"
        Call xmlsv.send(param)
        '"fault"
    End If
    On Error GoTo 0
    
    If checkError(xmlsv) = False Then
        Exit Function
    End If
    CallMethod = True
    Exit Function
conerr:
    err.Raise vbObjectError + 516, , "T[oɐڑł܂ł" & vbCrLf & err.Description
    CallMethod = False
End Function

'*
'* o[̍쐬
'* @param[in] sName 
'* @param[in] sDataType ^
'* @param[in] sValue l
'*
Private Function CreateMember(ByVal sName As String, ByVal sDataType As String, ByVal sValue As String) As XmlRpcMember
    Dim ret As XmlRpcMember
    Set ret = New XmlRpcMember
    ret.name = sName
    ret.DataType = sDataType
    ret.value = sValue
    Set CreateMember = ret
End Function

'*
'* Data̍쐬
'* @param[in] sDataType ^
'* @param[in] sValue l
'*
Private Function CreateData(ByVal sDataType As String, ByVal sValue As String) As XmlRpcData
    Dim ret As XmlRpcData
    Set ret = New XmlRpcData
    ret.DataType = sDataType
    ret.value = sValue
    Set CreateData = ret
End Function

'ResponseG[ǂ𔻒f܂B
'TODO:mF
Private Function checkError(ByRef xmlsv As XMLHTTP) As Boolean
    checkError = False
    Dim Members  As IXMLDOMNodeList
    Dim oNodeList As IXMLDOMNodeList

    Dim i As Long
    
    Set Members = xmlsv.responseXML.getElementsByTagName("fault")
    Dim errorMessage As String
    errorMessage = ""
    checkError = False
    If xmlsv.Status <= 100 Or xmlsv.Status > 200 Then
        'F؂ɎsƂHTTPɃANZXƂ܂ł̖̏
        err.Raise vbObjectError + 513, , "T[o玟̃G[Ԃ܂D" & _
            xmlsv.statusText & "(" & xmlsv.Status & ")"
    ElseIf Members.Length = 0 Then
        'faultꍇ͂XMLŃX|XmF܂D
        If xmlsv.responseXML.getElementsByTagName("methodResponse").Length > 0 Then
            checkError = True
            Exit Function
        End If
        err.Raise vbObjectError + 514, , "XMLł̉܂ł"
    Else
        'faultꍇG[bZ[W܂Ƃ߂܂
        Set Members = xmlsv.responseXML.getElementsByTagName("member")
        For i = 0 To Members.Length - 1
            Set oNodeList = Members.item(i).ChildNodes
            If oNodeList.item(0).text = "faultCode" Then
                errorMessage = errorMessage & "Code=" & oNodeList.item(1).text
            End If
            If oNodeList.item(0).text = "faultString" Then
                errorMessage = errorMessage & ":" & oNodeList.item(1).text
            End If
        Next
    End If
    If errorMessage <> "" Then
'        MsgBox errorMessage
        err.Raise vbObjectError + 515, , errorMessage
    End If
End Function


